# Copyright (C) 2008 azurIt (azurit@pobox.sk, azurIt@IRCnet)

from random import randint, choice
from copy import copy, deepcopy
from sys import exit

POCET_N = 35

class neuron:
	def __init__(self, vstup):
		self.u = vstup
		self.u2 = vstup
		# threshold, je vzdy 0
		self.xt = 0


	def output(self):
		global zmena, vahy, neurony
		u = 0
		ja = neurony.index(self)
		for i in xrange(len(neurony)):
			if neurony[i] != self:
				u += (neurony[i].u * vahy[ja][i])
		self.u2 = self.mk_output(u)
		if self.u != self.u2:
			zmena = True
		#return self.vystup


	def mk_output(self, y):
		if y > 0:
			return 1
		else:
			return -1


# vstupy sa davaju vo forme dvojrozmerneho pola, v kazdom riadku jedna sada
# v ktorej posledny prvok je to, co ma byt na vystupe (d)


vstupy_ucenie = [
	# A
	[
	[-1,-1,-1, 1,-1,-1,-1],
	[-1,-1, 1,-1, 1,-1,-1],
	[-1, 1, 1, 1, 1, 1,-1],
	[ 1,-1,-1,-1,-1,-1, 1],
	[ 1,-1,-1,-1,-1,-1, 1]
	],
	# B
	[
	[-1, 1, 1, 1, 1,-1,-1],
	[-1, 1,-1,-1,-1, 1,-1],
	[-1, 1, 1, 1, 1,-1,-1],
	[-1, 1,-1,-1,-1, 1,-1],
	[-1, 1, 1, 1, 1,-1,-1]
	],
	# X
	[
	[ 1,-1,-1,-1,-1,-1, 1],
	[-1, 1,-1,-1,-1, 1,-1],
	[-1,-1, 1, 1, 1,-1,-1],
	[-1, 1,-1,-1,-1, 1,-1],
	[ 1,-1,-1,-1,-1,-1, 1]
	],
	# C
	[
	[-1, 1, 1, 1, 1, 1,-1],
	[ 1, 1,-1,-1,-1, 1, 1],
	[ 1, 1,-1,-1,-1,-1,-1],
	[ 1, 1,-1,-1,-1, 1, 1],
	[-1, 1, 1, 1, 1, 1,-1]
	],
	# I
	[
	[-1, 1, 1, 1, 1, 1,-1],
	[-1,-1,-1, 1,-1,-1,-1],
	[-1,-1,-1, 1,-1,-1,-1],
	[-1,-1,-1, 1,-1,-1,-1],
	[-1, 1, 1, 1, 1, 1,-1]
	],
	# V
	[
	[ 1,-1,-1,-1,-1,-1, 1],
	[ 1,-1,-1,-1,-1,-1, 1],
	[-1, 1,-1,-1,-1, 1,-1],
	[-1,-1, 1,-1, 1,-1,-1],
	[-1,-1,-1, 1,-1,-1,-1]
	],
]




# inicializacia vah (vsetko nula)
vahy = []
for i in xrange(POCET_N):
	vahy.append([])
	for j in xrange(POCET_N):
		vahy[i].append(0)

# ucenie
vahy_zal = []
for vstup in vstupy_ucenie:
	for i in xrange(len(vstup)):
		for j in xrange(len(vstup[i])):
			riadok = []
			for i2 in xrange(len(vstup)):
				for j2 in xrange(len(vstup[i2])):
					if i == i2 and j == j2:
						riadok.append(0)
					else:
						riadok.append(1.0/POCET_N*vstup[i][j]*vstup[i2][j2])
			vahy_zal.append(riadok)
	for i in xrange(POCET_N):
		for j in xrange(POCET_N):
			vahy[i][j] += vahy_zal[i][j]
	vahy_zal = []


def nahodny():
	global vstupy
	riadok = []
	vstupy = []
	for i in xrange(POCET_N):
		riadok.append(choice([-1, 1]))
		if (i+1)/7*7 == i+1:
			vstupy.append(riadok)
			riadok = []





vzor = -1



vstupy = deepcopy(vstupy_ucenie[vzor])


if vzor < 0:
	nahodny()



# zasumenie v percentach
zasu = 0.6
#zasu = 0.4
#zasu = 0.6


# vybavovanie
ano1 = 0
ano2 = 0
ano3 = 0
nie = 0
for i in xrange(100):
	vstupy = deepcopy(vstupy_ucenie[randint(0, len(vstupy_ucenie)-1)])
	# zasumenie
	ok = 0
	mam = []
	while ok != int(POCET_N*zasu):
		ria = randint(0, 4)
		stl = randint(0, 6)
		if [ria, stl] not in mam:
			vstupy[ria][stl] = vstupy[ria][stl]*(-1)
			mam.append([ria, stl])
			ok += 1
	# vytvorenie neuronov - na vstup hodim vzor
	neurony = []
	for i in xrange(len(vstupy)):
		for j in xrange(len(vstupy[i])):
			neurony.append(neuron(vstupy[i][j]))
	zmena = True
	#while zmena:
	for i in xrange(6):
		zmena = False
		vysledok = []
		riadok = []
		# vypisanie vystupov
		for i in xrange(len(neurony)):
			if neurony[i].u == -1:
				print " ",
			else:
				print 1,
			riadok.append(neurony[i].u)
			if (i+1)/7*7 == i+1:
				vysledok.append(riadok)
				riadok = []
				print
		print '------------'
		# prekryv
		ok1 = 0
		for i in xrange(len(vstupy_ucenie[0])):
			for j in xrange(len(vstupy_ucenie[0][i])):
				if vstupy_ucenie[0][i][j] == vysledok[i][j]:
					ok1 += 1
		ok2 = 0
		for i in xrange(len(vstupy_ucenie[1])):
			for j in xrange(len(vstupy_ucenie[1][i])):
				if vstupy_ucenie[1][i][j] == vysledok[i][j]:
					ok2 += 1
		ok3 = 0
		for i in xrange(len(vstupy_ucenie[2])):
			for j in xrange(len(vstupy_ucenie[2][i])):
				if vstupy_ucenie[2][i][j] == vysledok[i][j]:
					ok3 += 1
		# energia siete
		e = 0
		for i in xrange(len(neurony)):
			for j in xrange(len(neurony)):
				e += (vahy[i][j] * neurony[i].u * neurony[j].u)
		e = e/-2
		#print "Energia: %s" % e
		#print "Prekryv (A): %0.2f%%" % (ok1/0.35)
		#print "Prekryv (B): %0.2f%%" % (ok2/0.35)
		#print "Prekryv (X): %0.2f%%" % (ok3/0.35)
		#print "------------"
		# iteracia
		for neur in neurony:
			neur.output()
		for neur in neurony:
			neur.u = neur.u2
	if ok1 == 35 or ok1 == 0:
		ano1 += 1
	elif ok2 == 35 or ok2 == 0:
		ano2 += 1
	elif ok3 == 35 or ok3 == 0:
		ano3 += 1
	else:
		nie += 1
print "Ano: %s%%" % (ano1+ano2+ano3)
print "Nie: %s%%" % nie
